//+------------------------------------------------------------------+
//|                                                   
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "leonid553"
#property link      "leonid553@ya.ru"
#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color1 Blue
#property indicator_color2 DarkTurquoise
#property indicator_color3 Red
#property indicator_color4 Yellow

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1

extern   string   Symbol_1          =  "SIF2";
extern   string   Symbol_2          =  "GCC2";
extern   bool     Avarage_Spread_B  =  true;    //    .   
extern   bool     Avarage_Spread_L  =  false;   //    .  
extern   double   Delta_Deviation   =  0.0002;  //   .  
extern   int      N_Bars            =  21;     // -    . 
extern   int      Last_bars         =  1;       //   ,    

extern   color    Color_1           =  Blue;
extern   color    Color_2           =  DarkTurquoise;
extern   color    Color_3           =  Red;
extern   color    Color_4           =  Yellow;

double SpreadBid[];// 
double Ava_spread[];//. .
double Deviation_UP[];// 
double Deviation_DOWN[];// 

string info;

//-----------------------------------------------------
int init(){  
   SetIndexBuffer(0,SpreadBid); 
   SetIndexBuffer(1,Ava_spread);
   SetIndexBuffer(2,Deviation_UP);
   SetIndexBuffer(3,Deviation_DOWN);
   SetIndexStyle (0,DRAW_LINE,EMPTY,EMPTY,Color_1);
   SetIndexStyle (1,DRAW_LINE,EMPTY,EMPTY,Color_2);
   SetIndexStyle (2,DRAW_LINE,EMPTY,EMPTY,Color_3);
   SetIndexStyle (3,DRAW_LINE,EMPTY,EMPTY,Color_4);
   
   info = "1- = "+Symbol_1+"  2- = "+Symbol_2+"    " ; 
   IndicatorShortName(info);   
   
   SetIndexLabel(0,"Spread "+Symbol_1+"/"+Symbol_2); 
   SetIndexLabel(1,"Average Spread");
   SetIndexLabel(2,"Upper");
   SetIndexLabel(3,"Lower");
   
   
   
   return(0); 
}
int deinit(){
   fObjDeleteByPrefix(WindowExpertName());
   Comment("");
}
//------------------------------------------------------
int start(){
         int ic=IndicatorCounted();
         int limit=Bars-ic-1;
         
         datetime daytimes[];
         static bool err;
         ArrayCopySeries(daytimes,MODE_TIME,Symbol_1,Period());
            if(GetLastError()==4066){
               Comment("   "+Symbol_1);
               err=true;
               return(0);
            }
         ArrayCopySeries(daytimes,MODE_TIME,Symbol_2,Period());
            if(GetLastError()==4066){
               Comment("   "+Symbol_2);
               err=true;
               return(0);
            }
            if(err){
               err=false;
               ic=0;
               Comment("");
            }

            if(ic==0){
               datetime MaxTime=MathMax(Time[Bars-1],MathMax(iTime(Symbol_1,0,iBars(Symbol_1,0)-1),iTime(Symbol_2,0,iBars(Symbol_2,0)-1)));
               limit=iBarShift(NULL,0,MaxTime,false);
               
               SetIndexDrawBegin(0,Bars-limit);
               SetIndexDrawBegin(1,Bars-limit+N_Bars);
               SetIndexDrawBegin(2,Bars-limit+N_Bars);
               SetIndexDrawBegin(3,Bars-limit+N_Bars);
            }
            
            for(int i=limit;i>=0;i--){
               int bn1=iBarShift(Symbol_1,0,Time[i],false);
               int bn2=iBarShift(Symbol_2,0,Time[i],false);
               double bidSymb1=iClose(Symbol_1,0,bn1);         
               double bidSymb2=iClose(Symbol_2,0,bn2);
               SpreadBid[i]=bidSymb1/bidSymb2;
            }
            if(Avarage_Spread_B){
               for(i=limit-1;i>=0;i--){
                  Ava_spread[i]=iMAOnArray(SpreadBid,0,N_Bars,0,0,i+Last_bars);
                  Deviation_UP[i]=Ava_spread[i]+Delta_Deviation;
                  Deviation_DOWN[i]=Ava_spread[i]-Delta_Deviation;
               }
            }
            if(Avarage_Spread_L){
               double Ava_spr=iMAOnArray(SpreadBid,0,N_Bars,0,0,i+Last_bars);
               double Dev_UP=Ava_spr+Delta_Deviation;
               double Dev_DOWN=Ava_spr-Delta_Deviation; 
               fObjHLine(WindowExpertName()+"_AVA",Ava_spr,Color_2,1,WindowFind(info),0,false);
               fObjHLine(WindowExpertName()+"_Dev_UP",Dev_UP,Color_3,1,WindowFind(info),0,false);
               fObjHLine(WindowExpertName()+"_Dev_DN",Dev_DOWN,Color_4,1,WindowFind(info),0,false);
            }

   return(0); 
}

void fObjHLine(
   string aObjectName,  // 1 
   double aPrice_1,     // 2 
   color aColor=Red,    // 3 
   int aWidth=1,        // 4 
   int aWindowNumber=0, // 5 
   int aStyle=0,        // 6 0-STYLE_SOLID, 1-STYLE_DASH, 2-STYLE_DOT, 3-STYLE_DASHDOT, 4-STYLE_DASHDOTDOT
   bool aBack=false     // 7 
   ){
      if(ObjectFind(aObjectName)!=aWindowNumber){
         ObjectCreate(aObjectName,OBJ_HLINE,aWindowNumber,0,aPrice_1);
      }      
   ObjectSet(aObjectName,OBJPROP_PRICE1,aPrice_1);   
   ObjectSet(aObjectName,OBJPROP_COLOR,aColor);
   ObjectSet(aObjectName,OBJPROP_WIDTH,aWidth);
   ObjectSet(aObjectName,OBJPROP_BACK,aBack);   
   ObjectSet(aObjectName,OBJPROP_STYLE,aStyle);            
}

void fObjDeleteByPrefix(string aPrefix){
   for(int i=ObjectsTotal()-1;i>=0;i--){
      if(StringFind(ObjectName(i),aPrefix,0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
}

